;;===================================================================================
;; gdm_m1_freistich.lsp
;; erstellt: gt / DC4 Technisches Buero GmbH
;; geaendert: os / 13.05.2008 11:41
;; Werteauswahl ueber Tabelle; Label fuer Freistich hinzu; Form G und H hinzu

(in-package  :GDM)
(use-package :OLI)

;;--------------------------------------------------------------------------*

(sd-create-logical-table "GDM_m1_freistich"
   :columns     '(  :DURCHMESSER  :FORM      :REIHE   :R1      :T1       :F1        :T2       :BELASTUNG)
   :columnNames '(
                  (sd-multi-lang-string
                    "fuer D."       "Form"     "Reihe"  "r"      "t1"      "f"        "t2"      "Belastung"
                   :german
                    "for D."       "Form"     "Row"    "r"      "t1"      "f"        "t2"      "Load"
                  );;sd-multi-lang-string
                 )
   :types       '(  :string       :string    :string  :length  :length   :length    :length   :string)
   :units       '(  nil           nil        nil      :mm      :mm       :mm        :mm       nil)
   :contents    (sd-multi-lang-string
                 '(
                   ;;Form E
                   ("> 1,6 - 3"   "E"        "2"      0.2      0.1       1.0        0.0       "normal")
                   ("> 3 - 18"    "E"        "1"      0.4      0.2       2.0        0.0       "normal")
                   ("> 10 - 18"   "E"        "2"      0.6      0.2       2.0        0.0       "normal")
                   ("> 18 - 80"   "E"        "2"      0.6      0.3       2.5        0.0       "normal")
                   ("> 18 - 80"   "E"        "1"      0.8      0.3       2.5        0.0       "normal")
                   ("> 18 - 50"   "E"        "2"      1.0      0.2       2.5        0.0       "increased")
                   ("> 80"        "E"        "2"      1.0      0.4       4.0        0.0       "normal")
                   ("> 18 - 50"   "E"        "1"      1.2      0.2       2.5        0.0       "increased")
                   ("> 80"        "E"        "1"      1.2      0.4       4.0        0.0       "normal")
                   ("> 50 - 80"   "E"        "1"      1.6      0.3       4.0        0.0       "increased")
                   ("> 80 - 125"  "E"        "1"      2.5      0.4       5.0        0.0       "increased")
                   ("> 125"       "E"        "1"      4.0      0.5       7.0        0.0       "increased")
                   ;;Form F
                   ("> 1,6 - 3"   "F"        "2"      0.2      0.1       1.0        0.1       "normal")
                   ("> 3 - 18"    "F"        "1"      0.4      0.2       2.0        0.1       "normal")
                   ("> 10 - 18"   "F"        "2"      0.6      0.2       2.0        0.1       "normal")
                   ("> 18 - 80"   "F"        "2"      0.6      0.3       2.5        0.2       "normal")
                   ("> 18 - 80"   "F"        "1"      0.8      0.3       2.5        0.2       "normal")
                   ("> 18 - 50"   "F"        "2"      1.0      0.2       2.5        0.1       "increased")
                   ("> 80"        "F"        "2"      1.0      0.4       4.0        0.3       "normal")
                   ("> 18 - 50"   "F"        "1"      1.2      0.2       2.5        0.1       "increased")
                   ("> 80"        "F"        "1"      1.2      0.4       4.0        0.3       "normal")
                   ("> 50 - 80"   "F"        "1"      1.6      0.3       4.0        0.2       "increased")
                   ("> 80 - 125"  "F"        "1"      2.5      0.4       5.0        0.3       "increased")
                   ("> 125"       "F"        "1"      4.0      0.5       7.0        0.3       "increased")
                   ;;Form G
                   ("> 3 - 18"    "G"        "1"      0.4      0.2       0.9        0.2       "normal")
                   ;;Form H
                   ("> 18 - 80"   "H"        "1"      0.8      0.3       2.0        0.05      "normal")
                   ("> 18 - 50"   "H"        "1"      1.2      0.3       2.4        0.05      "increased")
                  );;contents
                 :german
                 '(
                   ;;Form E
                   ("> 1,6 - 3"   "E"        "2"      0.2      0.1       1.0        0.0       "normal")
                   ("> 3 - 18"    "E"        "1"      0.4      0.2       2.0        0.0       "normal")
                   ("> 10 - 18"   "E"        "2"      0.6      0.2       2.0        0.0       "normal")
                   ("> 18 - 80"   "E"        "2"      0.6      0.3       2.5        0.0       "normal")
                   ("> 18 - 80"   "E"        "1"      0.8      0.3       2.5        0.0       "normal")
                   ("> 18 - 50"   "E"        "2"      1.0      0.2       2.5        0.0       "erhoeht")
                   ("> 80"        "E"        "2"      1.0      0.4       4.0        0.0       "normal")
                   ("> 18 - 50"   "E"        "1"      1.2      0.2       2.5        0.0       "erhoeht")
                   ("> 80"        "E"        "1"      1.2      0.4       4.0        0.0       "normal")
                   ("> 50 - 80"   "E"        "1"      1.6      0.3       4.0        0.0       "erhoeht")
                   ("> 80 - 125"  "E"        "1"      2.5      0.4       5.0        0.0       "erhoeht")
                   ("> 125"       "E"        "1"      4.0      0.5       7.0        0.0       "erhoeht")
                   ;;Form F
                   ("> 1,6 - 3"   "F"        "2"      0.2      0.1       1.0        0.1       "normal")
                   ("> 3 - 18"    "F"        "1"      0.4      0.2       2.0        0.1       "normal")
                   ("> 10 - 18"   "F"        "2"      0.6      0.2       2.0        0.1       "normal")
                   ("> 18 - 80"   "F"        "2"      0.6      0.3       2.5        0.2       "normal")
                   ("> 18 - 80"   "F"        "1"      0.8      0.3       2.5        0.2       "normal")
                   ("> 18 - 50"   "F"        "2"      1.0      0.2       2.5        0.1       "erhoeht")
                   ("> 80"        "F"        "2"      1.0      0.4       4.0        0.3       "normal")
                   ("> 18 - 50"   "F"        "1"      1.2      0.2       2.5        0.1       "erhoeht")
                   ("> 80"        "F"        "1"      1.2      0.4       4.0        0.3       "normal")
                   ("> 50 - 80"   "F"        "1"      1.6      0.3       4.0        0.2       "erhoeht")
                   ("> 80 - 125"  "F"        "1"      2.5      0.4       5.0        0.3       "erhoeht")
                   ("> 125"       "F"        "1"      4.0      0.5       7.0        0.3       "erhoeht")
                   ;;Form G
                   ("> 3 - 18"    "G"        "1"      0.4      0.2       0.9        0.2       "normal")
                   ;;Form H
                   ("> 18 - 80"   "H"        "1"      0.8      0.3       2.0        0.05      "normal")
                   ("> 18 - 50"   "H"        "1"      1.2      0.3       2.4        0.05      "erhoeht")
                  );;contents
                );;sd-multi-lang-string
);;sd-create-logical-table

(sd-create-display-table "GDM_m1_freistich"
     :tableTitle        (sd-multi-lang-string "Relief Grooves" :german "Freistiche")
     :logicalTable      "GDM_m1_freistich"
     :columns           '(:DURCHMESSER :FORM :REIHE :R1 :T1 :F1 :T2 :BELASTUNG)
     :applyColumns      '(:DURCHMESSER :FORM :REIHE :R1 :T1 :F1 :T2 :BELASTUNG)
     :displayHeight     400
     :columnSortUI      t
     :filterStatusLine  nil
     :selectionMode     :single-row
     :applyAction       :default-tokens
)


(sd-defdialog 'gdm-m1-freistich-dialog
  :dialog-title (sd-multi-lang-string "Relief Grooves" :german "Freistiche")
  :toolbox-button t
  :variables
  '(
     ;;lokal
     (BACK    :initial-value nil)
     (TEIL)       ;;Part             - wird in check-function gesetzt
     (CENTER)     ;;Kreismitte       - wird in check-function gesetzt
     (NORMAL)     ;;Flaechennormale   - wird in check-function gesetzt
     (START-DIR)  ;;Kanten-Start-Dir - wird in check-function gesetzt
     (RADIUS)     ;;Kanten-Radius    - wird in check-function gesetzt
     (AUSSEN)     ;;Außen / Innen    - wird in check-function gesetzt
     (INNEN)      ;;Außen / Innen    - wird in check-function gesetzt

     ;;dialog
     (BILD
       :value-type :image
;       :image-file (format nil "~a/LISP/gdm_m1_freistich.bmp" (oli::sd-convert-filename-from-platform (oli::sd-sys-getenv "SDCORPCUSTOMIZEDIR"))))
       :image-file "C:/ ... PFAD ANPASSEN ... /gdm_m1_freistich.bmp")

     (KKANTE
       :selection *sd-circle-3d-seltype*
       :multiple-items nil
       :modifies :contents
       :title (sd-multi-lang-string "Circle Edge" :german "Kreiskante")
       :prompt-text (sd-multi-lang-string "Specify Circle Edge of Relief Groove." :german "Kreiskante des Freistich angeben.")
       :initial-value nil
       :check-function
        #'(lambda (WERT)
            (let (KREIS EIG CYLLIST PLANELIST CYL PLANE CYLPROP PLANEPROP KPROP P_ON_PLANE P_ON_CYL PDIFF)
                 (setf KREIS nil)
                 (setf EIG (sd-inq-parent-obj WERT))
                 (when (sd-inq-part-p EIG)
                       (setf TEIL EIG)
                 );;when
                 (setf CYLLIST (sd-call-cmds (get_selection :focus_type *sd-cylinder-seltype* :select :by_edge_3d WERT)))
                 (setf PLANELIST (sd-call-cmds (get_selection :focus_type *sd-plane-seltype* :select :by_edge_3d WERT)))
                 (when (and (= 1 (length CYLLIST)) (= 1 (length PLANELIST)))
                   (progn
                    (setf CYL (first CYLLIST))
                    (setf CYLPROP (sd-inq-geo-props CYL :dest-space :global))
                    (setf PLANE (first planelist))
                    (setf PLANEPROP (sd-inq-geo-props PLANE :dest-space :global))
                    (setf KPROP (sd-inq-geo-props WERT :dest-space :global))
                    (setf NORMAL (sd-plane-normal PLANEPROP))
                    (setf CENTER (sd-circle-center KPROP))
                    (setf START-DIR (sd-circle-start-dir KPROP))
                    (setf RADIUS (sd-circle-radius KPROP))
                    (setf P_ON_PLANE (sd-get-pnt-on-face PLANE :dest-space :global))
                    (setf P_ON_CYL (sd-get-pnt-on-face CYL :dest-space :global))
                    (setf PDIFF (sd-vec-subtract P_ON_CYL P_ON_PLANE))
                    (when (and TEIL (sd-cylinder-p CYLPROP) (sd-plane-p PLANEPROP) (> (sd-vec-length (sd-vec-add NORMAL PDIFF)) (sd-vec-length PDIFF)))
                     (progn
                      (setf KREIS t)
                      (setf DURCHM (* 2 RADIUS))
                      (if (< (sd-vec-length (sd-vec-subtract P_ON_PLANE CENTER)) RADIUS)
                       (setf AUSSEN nil INNEN t)
                       (setf AUSSEN t INNEN nil)
                      );;if
                     );;progn
                    );;when
                   );;progn
                 );;when
                 (if KREIS
                     :ok
                     (values :error "Diese Kante hat nicht die richtigen Nachbarflaechen oder gehoert zu keinem Teil!")
                 );;if
            );;let
        );;lambda
       :after-input (setf DURCHM DURCHM)
     );;KANTE

     (DURCHM
       :value-type :display-only
       :title (sd-multi-lang-string "Diameter" :german "Durchmesser"))

     ("")
     (DURCHMESSER
       :value-type :string
       :show-input-tool (sd-show-display-table "GDM_m1_freistich" :position '("TOP-MENU-TOOLBOX-TB" :bottomleft 330 250))
       :hide-input-tool (sd-hide-display-table "GDM_m1_freistich" :ignorePin t)
       :title (sd-multi-lang-string "for D." :german "fuer D."))

     (FORM
       :value-type :string
       :title (sd-multi-lang-string "Type" :german "Form"))

     (REIHE
       :value-type :string
       :title (sd-multi-lang-string "Row" :german "Reihe"))

     (R1
       :value-type :positive-number
       :title (sd-multi-lang-string "Radius R1" :german "Radius R1"))

     (T1
       :value-type :positive-number
       :title (sd-multi-lang-string "Depth T1" :german "Tiefe T1"))

     (F1
       :value-type :positive-number
       :title (sd-multi-lang-string "Length F" :german "Laenge F"))

     (T2
       :value-type :length
       :title (sd-multi-lang-string "Depth T2" :german "Tiefe T2"))

     (BELASTUNG
       :value-type :string
       :title (sd-multi-lang-string "Load" :german "Beanspruchung"))

     ("")
     (NEXT
       :push-action (next-action)
       :title (sd-multi-lang-string "Next" :german "Naechstes")
       :next-variable 'KKANTE)

  );;variables

  :local-functions
  '(

    (next-action ()
     (let (AKT_WP OLD-ZYL-KANTEN NEW-ZYL-KANTEN NEBEN-FLAECHEN)

      ;; aktuelle AE merken
      (setf AKT_WP (sd-inq-curr-wp))

      ;; Liste 1 aller Zylinderkanten des aktuellen Teils erstellen
      (sd-call-cmds (current_part TEIL))
      (sd-call-cmds (get_selection  :focus_type *sd-circle-3d-seltype* :curr_part_only :select :all_3d)
                                    :failure (setf OLD-ZYL-KANTEN nil)
                                    :success (setf OLD-ZYL-KANTEN *SD-ACTION-RESULT*))

      ;; AE erstellen
      (sd-call-cmds (create_workplane :new))
      (sd-call-cmds (position_wp :current :pt_pt_pt CENTER (sd-vec-add CENTER NORMAL) (sd-vec-add CENTER START-DIR)))

      ;; Geo Mode einstellen
      (GEOMETRY_MODE :REAL)

      ;; Freistich erstellen
      (cond
        ((or (string= FORM "E") (string= FORM "F"))
         (OS-freistich-form-e-und-f-erstellen)
        )
        ((or (string= FORM "G") (string= FORM "H"))
         (OS-freistich-form-g-und-h-erstellen)
        )

      );;cond

      ;; Liste 2 aller Zylinderkanten des aktuellen Teils erstellen
      (sd-call-cmds (get_selection :focus_type *sd-circle-3d-seltype* :curr_part_only :select :all_3d)
                                   :failure (setf NEW-ZYL-KANTEN nil)
                                   :success (setf NEW-ZYL-KANTEN *SD-ACTION-RESULT*))

      ;; Liste 1 und 2 vergleichen und Label an Kante erstellen
      (if (null NEW-ZYL-KANTEN)
          (sd-display-message (sd-multi-lang-string "Error! There are no new Cylinder Edges." :german "Fehler! Das Modell hat keine neuen Zylinderkanten."))
          (dolist (A-EDGE NEW-ZYL-KANTEN)
            (when (not (member A-EDGE OLD-ZYL-KANTEN :test #'equal))
                  (if (sd-num-equal-p (sd-circle-radius (sd-inq-geo-props A-EDGE :dest-space :global)) RADIUS :resolution 0.0000001)
                      (Cocreate_3d_note :action :create :items A-EDGE
                                        :note (format nil "DIN 509-~a~ax~a" FORM (sd-string-replace (sd-num-to-string R1 2) "." ",") (sd-string-replace (sd-num-to-string T1 2) "." ",")))
                   );;if
            );;when
          );;dolist
      );;if

      ;; falls vorhanden alte AE aktiv setzen
      (if AKT_WP (current_wp AKT_WP) nil)

     );;let
     (setf KKANTE nil)
    );;next-action

    (OS-freistich-form-e-und-f-erstellen ()

      ;;      ^ Y                  |            ^ Y                      |
      ;;      |                    |            |                        |
      ;;                           |                                     |
      ;;                           |            * P4    * P5      *      |
      ;;                           |            |                 |      |
      ;;      * P4    * P5         |            |                 | FAS2 |
      ;;      |                    |            |                 |      |
      ;;      |       *-------     |            |       *-------  *      |
      ;;      |      / P1          |            |      / P1              |
      ;;      *-----*              |         *--------*                  |
      ;;      P3     P2            |          P3       P2                |
      ;;            *-*FAS1        |         *--*FAS3 *-*FAS1            |
      ;;      |                    |            |                        |
      ;;      *--     --> X        |            *--     --> X            |
      ;;      0,0                  |            0,0                      |
      ;;                           |                                     |
      ;;      FORM E               |            FORM F                   |

     (let (BOG8 FAS1 FAS2 FAS3 P1 P2 P3 P4 P5)

      (setf BOG8 (/ (* pi 8) 180))
      (setf FAS1 (/ T1 (tan (/ (* pi 15) 180))))
      (setf FAS2 (-  (+ R1 (* R1 (sin BOG8))  (/ (- (+ T2 (* R1 (cos BOG8))) R1) (tan BOG8))) T1))
      (setf FAS3 (* (+ FAS2 T1) (tan BOG8)))

      ;; Abfrage Form und berechnen der Punkte
      (cond
        ;;Form E
        ((string= FORM "E")
                (setf P1 (make-gpnt2d :x F1 :y RADIUS)
                      P2 (make-gpnt2d :x (- F1 FAS1) :y (- RADIUS T1))
                      P3 (make-gpnt2d :x 0 :y (- RADIUS T1))
                      P4 (make-gpnt2d :x 0 :y (+ R1 (- RADIUS T1)))
                      P5 (make-gpnt2d :x F1 :y (+ R1 (- RADIUS T1))))
        );;Form E

        ;; Form F
        ((string= FORM "F")
               (setf P1 (make-gpnt2d :x F1 :y RADIUS)
                     P2 (make-gpnt2d :x (- F1 FAS1) :y (- RADIUS T1))
                     P3 (make-gpnt2d :x (- 0 FAS3) :y (- RADIUS T1))
                     P4 (make-gpnt2d :x 0 :y (+ RADIUS FAS2))
                     P5 (make-gpnt2d :x F1 :y (+ RADIUS FAS2)))

        );;Form F
      );;cond

      ;; Absatz erstellen (wegen Radius)
      (sd-call-cmds (rectangle P3 P5))
      ;; Bei Bohrung die Geometrie spiegeln
      (if INNEN (sd-call-cmds (mirror_2d :select :edge_2d :all_2d :keep :off :horizontal RADIUS)));;if
      (sd-call-cmds (turn :part (sd-inq-obj-pathname TEIL) :axis :u :keep_profile :no :keep_wp :yes))
      ;; Freistich erstellen
      (sd-call-cmds (polygon P1 P2 P3 P4 P5 :close))
      (sd-call-cmds (fillet :create :fillet_radius R1 P2 P3))
      ;; Bei Bohrung die Geometrie spiegeln
      (if INNEN (sd-call-cmds (mirror_2d :select :edge_2d :all_2d :keep :off :horizontal RADIUS)));;if
      (sd-call-cmds (bore :parts (sd-inq-obj-pathname TEIL) :axis :u :keep_wp :no :rotation_angle (* 2 pi)))

     );;let
    );;OS-freistich-form-e-und-f-erstellen

    (OS-freistich-form-g-und-h-erstellen ()
      ;;         ^ Y                  |
      ;;         |                    |
      ;;                              |
      ;;         |                    |
      ;;         |                    |
      ;;         * P4                 |
      ;;        .                     |
      ;;       .            P1        |
      ;;      * P3        *--------   |
      ;;  t2 x   *P5      .           |
      ;;       .    * P2              |
      ;;         x t1                 |
      ;;                              |
      ;;                              |
      ;;         |                    |
      ;;         *--     --> X        |
      ;;         0,0                  |
      ;;                              |
      ;;         FORM G / H           |

     (let (WINKEL SL2 BSL A_T1 B_T1 A_T2 B_t2 P0 P1 P2 P3 P4 P5)
       (if (string= FORM "G")
           (setf WINKEL 35)
           (setf WINKEL 30)
       );;if
       ;; Sehnenlaenge /2
       ;; x-Wert der Strecke zwischen den Punkten t1 - P2
       ;; y-Wert Strecke zwischen den Punkten t2 - P3
       (setf SL2 (/ (* 2 R1 (sin (sd-deg-to-rad (/ WINKEL 2)))) 2))
       ;; Breite Sehnenlaenge
       ;; x-Wert Strecke zwischen den Punkten t2 - P3
       ;; y-Wert der Strecke zwischen den Punkten t1 - P2
       (setf BSL (* SL2 (tan (sd-deg-to-rad (/ WINKEL 4)))))
       ;; Dreieckseite A_T1
       ;; y-Wert der Strecke P2 - P1
       (setf A_T1 (- T1 BSL))
       ;; Dreieckseite B_T1
       ;; x-Wert der Strecke P2 - P1
       (setf B_T1 (/ A_T1 (tan (sd-deg-to-rad (/ WINKEL 2)))))
       ;; Dreieckseite A_T2
       ;; x-Wert der Strecke P3 - P4
       (setf A_T2 (- T2 BSL))
       ;; Dreieckseite B_T2
       ;; x-Wert der Strecke P3 - P4
       (setf B_T2 (/ A_T2 (tan (sd-deg-to-rad (/ WINKEL 2)))))

       ;; Punkte setzen
       ;; P0 = Eckpunkt - fuer Absatz
       (setf P0 (make-gpnt2d :x 0 :y RADIUS))
       (setf P1 (make-gpnt2d :x (+ (- R1 T2) SL2 B_T1) :y RADIUS))
       (setf P2 (make-gpnt2d :x (+ (- R1 T2) SL2) :y (+ (- RADIUS T1) BSL)))
       (setf P3 (make-gpnt2d :x (+ (- T2) BSL) :y (+ (- RADIUS T1) R1 SL2)))
       (setf P4 (make-gpnt2d :x 0 :y (+ (- RADIUS T1) R1 SL2 B_T2)))
       ;; P5 = Mittelpunkt von R1
       (setf P5 (make-gpnt2d :x (- R1 T2) :y (+ (- RADIUS T1) R1)))

       ;; Absatz erstellen (wegen Radius)
       (sd-call-cmds (polygon P0 P1 P4 :close))
       ;; Bei Bohrung die Geometrie spiegeln
       (if INNEN (sd-call-cmds (mirror_2d :select :edge_2d :all_2d :keep :off :horizontal RADIUS)));;if
       (sd-call-cmds (turn :part (sd-inq-obj-pathname TEIL) :axis :u :keep_profile :no :keep_wp :yes))

       ;; Freistich erstellen
       (sd-call-cmds (line :two_points P3 P4 P4 P1 P1 P2))
       (sd-call-cmds (arc :cen_rad_ang P5 R1 P3 P2))
       ;; Bei Bohrung die Geometrie spiegeln
       (if INNEN (sd-call-cmds (mirror_2d :select :edge_2d :all_2d :keep :off :horizontal RADIUS)));;if
       (sd-call-cmds (bore :parts (sd-inq-obj-pathname TEIL) :axis :u :keep_wp :no :rotation_angle (* 2 pi)))

     );;let
    );;OS-freistich-form-g-erstellen

  );;local-functions

  :ok-action '(next-action)

);;sd-def-dialog
